class CMonitors {
    public:
       CMonitors();
       BOOL Initialize();

       BOOL ScreenToVirtual(CRect & r);
       BOOL ScreenToVirtual(CPoint & pt);

       BOOL VirtualToScreen(CRect & r);
       BOOL VirtualToScreen(CPoint & pt);

       BOOL LeftLimitFrom(CPoint & pt);
       BOOL RightLimitFrom(CPoint & pt);
       BOOL TopLimitFrom(CPoint & pt);
       BOOL BottomLimitFrom(CPoint & pt);
    protected:
       BOOL valid;
       CArray<int, int>SortX;
       CArray<int, int>SortY;

       CArray<MONITORINFOEX, MONITORINFOEX&> monitors;
       CArray<CRect, CRect &> VirtualRects;
       // The real and object monitorprocs
       BOOL monitorproc(HMONITOR monitor, HDC, LPRECT rect);
       static BOOL CALLBACK monitorproc(HMONITOR monitor, HDC dc, LPRECT rect, LPARAM data);
       typedef enum {ByX, ByY} SortBy;
       void Sort(CArray<int, int> & data, SortBy what);

       BOOL CheckValid();
};

#define MONITORS_ERR_UNINITIALIZED  OLE_E_BLANK
#define MONITORS_ERR_INIT_FAILURE   ERROR_INTERNAL_ERROR
#define MONITORS_ERR_OUT_OF_BOUNDS  ERROR_DS_SIZELIMIT_EXCEEDED
